#ifndef MLSCOLORSET_H
#define MLSCOLORSET_H

#include <map>
#include <string>
#include "drawutil.h"

using namespace std;

namespace MLS {

/**
@author SJ, Lee
*/
class ColorSet
{
	ColorSet();
	~ColorSet();
	
public:	
	static ColorSet &getInstance();
	
	bool      Init();
	bool      Load(const char *);
	
	ColorEntry
		MCD,
		MCDLine,
		MCDstat,
		Dir,
		Drive,
		Line,
		Func,
		FuncA,
		Stat,
		StatA,
		Help,
		QCD,
		Dialog,
		Default,
		Back;
	
	std::map<std::string, ColorEntry> mapName;
	std::map<std::string, ColorEntry> mapExt;
	std::map<int, ColorEntry> mapMask;
};

extern ColorSet& e_tColor;

};

#endif
