///	\file	conf.h	
///	\brief	config header
#ifndef __CONFIG_H__
#define __CONFIG_H__

#include <vector>
#include <list>
#include <string>
#include <map>
#include <fstream>

#include <pwd.h>
#include <unistd.h>
#include <sys/stat.h>

#include "define.h"
#include "strutil.h"
#include "drawutil.h"
#include "action.h"
#include "StringTokenizer.h"

namespace MLS {
	
/// \brief	config class
class Config
{
public:
	std::string filter; ///< 필터
	std::string date_type,			///< date format 지정
			extern_viewer,			///< viewer 프로그램 지정 (vi)
			extern_editor;			///< editor 프로그램 지정(vi)
	std::string home,				///< home dir(~/)
			cfghome,				///< config home dir(~/.mls)
			mcdroot;				///< mcd root directory
	std::string colorset;			///< colorset(mls.col)
		
	std::map<std::string, Action> ext_prog;			///< ext prog

	Action Func[12];  ///< F1~F12
	Action McdFunc[12];///< F1~F12
	Action McdZipFunc[12];///< F1~F12
	Action aFunc[12]; ///< F1~F12
	Action cFunc[12]; ///< F1~F12
	
	// toggle
	bool ShowHidden;	///< .으로 시작하는 파일 보이기..
	bool AutoDrawmode;  ///< 그리기 방식을 자동으로 선택.
	bool FixedRow;      ///< 고정된 세로줄
	bool DirSort;		///< DirSort
	bool McdSort;		///< McdSort
	bool QMcdExit;		///< McdExit 시 물어봄
	bool QMlsExit;		///< MlsExit 시 물어봄

	int sort;           ///< 정렬방식
	int column;      ///< 그리기 방식(컬럼수)

	Config();
	~Config();
	
	bool Init();

	void set_default();
	int  load(const char *);
};

extern Config e_tConf;			///< Config extern 변수

}; // namespace

#endif
