///	\file	help.cpp
///	\brief	help.cpp

#include <ncurses.h>
#include "mlslocale.h"
#include "panel.h"
#include "config.h"
#include "strutil.h"

using namespace MLS;
using namespace strutil;

static char *help;

int MLS::Panel::about()
{
	int width = 40;
	int height = 12;
	
	width +=4;
			
	WINDOW *win = newwin(height, width, (LINES-height)/2, (COLS-width)/2);
	wclear(win);
	wbkgd(win, COLOR(COLOR_WHITE, 3));
	
	wattron(win ,A_BOLD);
	wborder(win, VLINE, VLINE, HLINE, HLINE, ULCORNER, URCORNER, LLCORNER, LRCORNER);
	
	wattroff(win, A_BOLD);
	
	// title 출력
	wattron(win, COLOR(COLOR_BLACK, COLOR_WHITE));
	wmove(win, 1, 1);
	whline(win, ' ', width-2);
	string sTitle = gettext("About Mls");
	mvwprintw(win, 1, (40 - krstrlen(sTitle))/2, sTitle.c_str());
	wattroff(win, A_BOLD);
	
	// msg
	wattron (win, COLOR(COLOR_WHITE, 3));
	wattron (win, A_BOLD);
	mvwprintw(win, 3, 2, gettext("Mls %s - User-Interfaced File Manager "), VERSION);
	mvwprintw(win, 5, 2, gettext("Author : "));
	mvwprintw(win, 6, 2, gettext("  IOKLO  (ioklo@kldp.net)"));
	mvwprintw(win, 7, 2, gettext("  Byoungyoung, La (la9527@yahoo.co.kr)"));
	mvwprintw(win, 8, 2, gettext("  fehead (fehead@kldp.net)"));
	mvwprintw(win, 10, 2, "(c) 2004 The Mls Developers");
	wattroff(win, A_BOLD);
	
	wrefresh(win);
	
	getch();	
	delwin(win);		
	return 1;	
}

int MLS::Panel::cmd_help()
{	
	int width = 70;
	int height = 17;
	
	width +=4;
			
	WINDOW *win = newwin(height, width, (LINES-height)/2, (COLS-width)/2);
	wclear(win);
	wbkgd(win, COLOR(COLOR_WHITE, 3));
	
	wattron(win ,A_BOLD);
	wborder(win, VLINE, VLINE, HLINE, HLINE, ULCORNER, URCORNER, LLCORNER, LRCORNER);
	
	wattroff(win, A_BOLD);
	
	// title 출력
	wattron(win, COLOR(COLOR_BLACK, COLOR_WHITE));
	wmove(win, 1, 1);
	whline(win, ' ', width-2);
	string sTitle = gettext("Help");
	mvwprintw(win, 1, (70 - krstrlen(sTitle))/2, sTitle.c_str());
	wattroff(win, A_BOLD);
	
	// msg
	wattron (win, COLOR(COLOR_WHITE, 3));
	wattron (win, A_BOLD);
	
	mvwprintw(win, 3, 2, gettext("/ , \\   : Shell"));
	mvwprintw(win, 4, 2, gettext("Alt+C   : File Copy"));
	mvwprintw(win, 5, 2, gettext("Alt+D   : File Delete"));
	mvwprintw(win, 6, 2, gettext("Alt+K   : Mkdir"));
	mvwprintw(win, 7, 2, gettext("Alt+R   : Rename"));
	mvwprintw(win, 8, 2, gettext("Alt+Q   : History Prev"));
	mvwprintw(win, 9, 2, gettext("Alt+W   : History Next"));
	mvwprintw(win, 10, 2, gettext("Alt+T   : Command Shell View"));
	mvwprintw(win, 11, 2, gettext("Alt+Z   : Hidden file view on/off"));
	mvwprintw(win, 12, 2, gettext("Alt+L   : BoxLine code chage"));
	mvwprintw(win, 13, 2, gettext("Alt+1   : Multi View"));
	mvwprintw(win, 14, 2, gettext("Alt+X   : Exit"));

	mvwprintw(win, 3,  40, gettext("F1    : Help"));
	mvwprintw(win, 4,  40, gettext("F2    : Rename"));
	mvwprintw(win, 5,  40, gettext("F3    : Vi"));
	mvwprintw(win, 6,  40, gettext("F4    : Edit"));
	mvwprintw(win, 7,  40, gettext("F5    : Refresh"));
	mvwprintw(win, 8,  40, gettext("F6    : Move"));
	mvwprintw(win, 9,  40, gettext(	"F7    : Make directory (mkdir)"));
	mvwprintw(win, 10, 40, gettext(	"F8    : Delete (rm)"));
	mvwprintw(win, 11, 40, gettext(	"F9    : Extract"));
	mvwprintw(win, 12, 40, gettext(	"F10   : MCD"));
	mvwprintw(win, 13, 40, gettext(	"F11   : Configure Editor"));
	mvwprintw(win, 14, 40, gettext(	"F12   : Menu"));
	wattroff(win, A_BOLD);
	
	wrefresh(win);
	
	getch();	
	delwin(win);		
	return 1;	
}
