///	\file	panel_reader.cpp
///	\brief	panel_reader.cpp
#include <string>

#include "panel.h"
#include "reader.h"
#include "ZipReader.h"
#include "dirreader.h"

using namespace std;
using namespace MLS;

/// \brief	절대경로에 맞는 Reader를 얻어온다	
///	\param	path	절대경로
/// \return	절대경로에 맞는 reader
Reader *Panel::GetReader(const string &path)
{
	if (path.empty()) return NULL;

	if (m_nZip == 0)
	{
		LOG("PATH Dir :: %s", path.c_str());
		static DirReader dir_reader;
		
		// /로 시작하고.. 끝이 /으로 끝난다면..
		if (path[0] == '/' && path[path.size()-1] == '/')
			return &dir_reader;
	}
	else
	{
		LOG("PATH Zip :: %s", path.c_str());
		static ZipReader zip_reader;
		
		if (m_sZipFile.empty()) return NULL;
		
		zip_reader.SetZipFile(path, m_sZipFile);
		return &zip_reader;
	}

	return NULL;
}
